; FORTH COMPILER/INTERPRETER V1.1
;
 .BA $2000
 .MC $A000
 .OC
 .CE
;
^ .DE $80
_A .DE $C1
_B .DE $C2
_C .DE $C3
_D .DE $C4
_E .DE $C5
_F .DE $C6
_G .DE $C7
_H .DE $C8
_I .DE $C9
_J .DE $CA
_K .DE $CB
_L .DE $CC
_M .DE $CD
_N .DE $CE
_O .DE $CF
_P .DE $D0
_Q .DE $D1
_R .DE $D2
_S .DE $D3
_T .DE $D4
_U .DE $D5
_V .DE $D6
_W .DE $D7
_X .DE $D8
_Y .DE $D9
_Z .DE $DA
;
;
;ZERO PAGE DEFINITIONS
;
BOS .DE 0 ;BOSTOM OF STACK
TOS .DE $9E ;TOP OF STACK
N .DE TOS+8 ;SCRATCH WORKSPACE
IP .DE N+8 ;INTERPRATIVE POINTER
W .DE IP+3 ;CODE FIELD POINTER
UP .DE W+2 ;USER AREA POINTER
XSAVE .DE  UP+2 ;DATA STACKPOINTER TEMP
;
;I/O
;
^TIB .DE $100 ;TERMINAL INPUT BUFFER
;
MAXSCR .DE 16 ;MAX 16 SCREENS IN RAM-DISK
BUFMAG .DE 1040 ;BUFFER SIZE
MEM .DE $A000 ;TOP ASSIGNED MEMORY+1
USERAREA .DE MEM-128 ;USER AREA
BUFAREA .DE USERAREA-BUFMAG
;
;MONITOR SUBROUTINES
;
OUTCH .DE $0C80 ;CHARACTER OUT
INCH .DE $0D08 ;GET A KEY
;
;
;
ORIG
;
;
;
;
;
]LIT .BY ^+3 'LI' _T
 .SE 0
LIT .SI \LIT
\LIT LDA (IP),Y
 PHA
 INC *IP
 BNE LIT1
 INC *IP+1
LIT1 LDA (IP),Y
CLIT1 INC *IP
 BNE PUSH
 INC *IP+1
;
PUSH DEX
 DEX
;
PUT STA *BOS+1,X
 PLA
 STA *BOS,X
;
NEXT LDY #1
NEXTY1 LDA (IP),Y
 STA *W+1
 DEY
 LDA (IP),Y
 STA *W
 CLC
 LDA *IP
 ADC #2
 STA *IP
 BCC JMP[W]
 INC *IP
JMP[W] JMP W-1
;
]CLIT .BY ^+4
 .BY 'CLI' _T
 .SI ]LIT
CLIT .SI \CLIT
\CLIT LDA (IP),Y
 PHA
 TYA
 BEQ CLIT1
;
]EXECUTE .BY ^+7
 .BY 'EXECUT' _E
 .SI ]CLIT
EXECUTE .SI \EXECUTE
\EXECUTE LDA *BOS,X
 STA *W
 LDA *BOS+1,X
 STA *W+1
 INX
 INX
 JMP W-1
;
]BRANCH .BY ^+6
 .BY 'BRANC' _H
 .SI ]EXECUTE
BRANCH .SI \BRANCH
\BRANCH CLC
 LDA (IP),Y
 ADC *IP
 PHA
 INY
 LDA (IP),Y
 ADC *IP+1
 STA *IP+1
 PLA
 STA *IP
 JMP NEXTY1
;
]0BRANCH .BY ^+7
 .BY '0BRANC' _H
 .SI ]BRANCH
_0BRANCH .SI \0BRANCH
\0BRANCH INX
 INX
 .EN
