




   *******************************
   ***** MICRO-ADE ASSEMBLER *****
   ***** (C) COPYRIGHT  1977 *****
   ***** MICRO-WARE  LIMITED *****
   ***** 27 FIRSTBROOKE  RD. *****
   ***** TORONTO,    CANADA  *****
   *******************************



ASMBLR ORG $25F8 77.06.28

   PAGE ZERO SYMBOLS

BLO * $0010 WS POINTER
BHI * $0011
NLO * $0015 CURRENT LINE NUMBER
NHI * $0016
LOPAR * $001A COMMAND INPUT PARAMETERS
HIPAR * $001D
LABEL * $0020 LABEL INPUT
OPIN * $0026 INSTRUCTION INPUT
AD * $0029 ADDRESS MODE INPUT
ARGIN * $002B ARGUMENT INPUT
YCOM * $0031 COMMENT POINTER
PLAB * $0032 PACKED LABEL
POP * $0036 PACKED INSTRUCTION
TMP * $003C TEMPORARY DATA
PCLO * $003D ASSEMBLY ADDRESS
PCHI * $003E 
SLO * $003F SYMBOL TABLE POINTER
SHI * $0040
ELO * $0041 END OF SYMBOL TABLE
EHI * $0042
SXL * $0043 TEMP SYMBOL TABLE POINTER
SXH * $0044
ADM * $0045 ADDRESS MODE
LENGTH * $0046 INSTRUCTION LENGTH
OP * $0047 OP-CODE (OBJECT BYTE 1)
PCALO * $004A OBJECT OUTPUT POINTER
PCAHI * $004B
PASS * $004C PASS FLAG
PRFLAG * $004D PRINT FLAG
SAVE * $0051 SAVE FLAG
PAGE * $0055 PAGE NUMBER
PGN * $0056 LINE IN PAGE
TITLE * $0057 TITLE
SAVID * $005D ID TEMPORARY
SALX * $0060 START ADDRESS FOR CWRITE
SAHX * $0061
ID * $0062 ID FOR CWRITE
BUFFER * $0100 I/O BUFFER

INDX * $0027
SPCNT * $0028 SPACE COUNT FOR DSMBLR
XCLO * $0029 SYMBOL TABLE PTR FOR DSMBLR
XCHI * $002A
X * $002B TEMPORARY DATA


   PAGE 17 DATA FOR KIM CREAD/CWRITE

SAL * $17F5 START ADDRESS
SAH * $17F6
EAL * $17F7 END ADDRESS
EAH * $17F8

   EXTERNAL SUBROUTINES

PACKT * $2E94 PACK ASCII TO HEX
LOAD * $24FB FROM WS
OUT * $24DE BUFFER OUT 1 LINE
READ * $2E97 CASSETTE READ
WRITE * $2E9A CASSETTE WRITE
INCH * $2E2B INPUT CHARACTER
HEXSP * $2DEB OUTPUT 2 BYTES + SPACE
ERRPRT * $240C PRINT ERROR
OUTK * $2DF0 OUTPUT 1 CHARACTER
HEXOUT * $2DCD OUTPUT 1 HEX BYTE
BUFIN * $2E41 BUFFER IN
RESTRT * $2031 EDITOR ENTRY
RESB * $23F4 RESET BLO,BHI
INCBUF * $250D INC BLO,BHI
NOUT * $2DC5 OUTPUT N
DPSYM * $25AC PRINT SYMBOL
ZUTSP * $2DEE OUTPUT SPACE
HEXAX * $2DC9 OUTPUT 2 HEX BYTES
SETSY * $25E6 SET SLO
ZRLF * $2DE7 CRLF

   WORKSPACE PARAMETER DEFINITION

SOURCE * $2EA4 SOURCE DEFINITIION
SYMBOL * $2EA6 SYMBOL TABLE DEFINITION
ENDSYM * $2EA7 SYMBOL TABLE END
OBJECT * $2EA8 OBJECT DEFINITION
BINARY * OBJECT


