
   JUNIOR'S MAINROUTINES

SAVE STA ACC SAVE ACCU
 PLA  GET CURRENT P-REGISTER
 STA PREG SAVE P-REGISTER
SAVEA PLA  GET CURRENT PCL
 STA PCL SAVE CURRENT PCL
 STA POINTL PCL TO DISPLAY BUFFER
 PLA  GET CURRENT PCH
 STA PCH SAVE CURRENT PCH
 STA POINTH PCH TO DISPLAY BUFFER
SAVEB STY YREG SAVE CURRENT Y-REGISTER
 STX XREG SAVE CURRENT X-REGISTER
 TSX  GET CURRENT SP
 STX SPUSER SAVE CURRENT SP
 LDXIM $01 SET AD-MODE
 STX MODE
 JMP START

RESET LDAIM $1E PB1---PB4
 STA PBDD IS OUTPUT
 LDAIM $04 RESET P-REGISTER
 STA PREG
 LDAIM $03
 STA MODE SET AD-MODE
 STA BYTES DISPLAY POINTH,POINTL,INH
 LDXIM $FF ADJUST THE STACKPOINTER
 TXS
 STX SPUSER
 CLD
 SEI

START JSR SCAND DISPLAY DATA SPECIFIED BY POINT
 BNE START WAIT UNTIL KEY IS RELEASED
STARA JSR SCAND DISPLAY DATA SPECIFIED BY POINT
 BEQ STARA ANY KEY DEPRESSED?
 JSR SCAND DEBOUNCE KEY
 BEQ STARA ANY KEY STILL DEPRESSED?
 JSR GETKEY THEN DECODE KEY, RETURN KEY IN ACCU

GOEXEC CMPIM $13 GO-KEY?
 BNE ADMODE
 LDX SPUSER GET CURRENT SP
 TXS
 LDA POINTH START EXECUTION AT POINT
 PHA
 LDA POINTL
 PHA
 LDA PREG RESTORE CURRENT P REGISTER
 PHA
 LDX XREG
 LDY YREG
 LDA ACC
 RTI  EXECUTE PROGRAM
ADMODE CMPIM $10 AD-KEY?
 BNE DAMODE
 LDAIM $03 SET AD-MODE
 STA MODE
 BNE STEPA

DAMODE CMPIM $11 DA-KEY?
 BNE STEP
 LDAIM $00 SET DA-MODE
 STA MODE
 BEQ STEPA

STEP CMPIM $12 PLUS-KEY?
 BNE PCKEY
 INC POINTL POINT+:=1
 BNE STEPA
 INC POINTH
STEPA JMP START

PCKEY CMPIM $14 PC-KEY?
 BNE ILLKEY
 LDA PCL
 STA POINTL LAST PC TO DISPLAY BUFFER
 LDA PCH
 STA POINTH
 JMP STEPA

ILLKEY CMPIM $15 ILLEGAL KEY
 BPL STEPA IF YES, IGNORE IT

DATA STA KEY SAVE KEY
 LDY MODE Y=0: DATA MODE, ELSE ADDRESS MODE
 BNE ADDRES
 LDAIY POINTL GET DATA SPECIFIED
 ASLA  BY POINT
 ASLA  SHIFT LOW OPDER
 ASLA  NIBBLE INTO HIGH ORDER NIBBLE
 ASLA
 ORA KEY DATA WITH KEY
 STAIY POINTL RESTORE DATA
 JMP STEPA
 
ADDRES LDXIM $04 4 SHIFTS
ADLOOP ASL POINTL POINTH,POINTL 4 POSITIONS TO LEFT
 ROL POINTH
 DEX
 BNE ADLOOP
 LDA POINTL
 ORA KEY RESTORE ADDRESS
 STA POINTL
 JMP STEPA


