
   ADCEND ADVANCES CURRENT END ADDRESS
   DOWNWARD BY THE AMOUNT IN BYTES

ADCEND CLC
 LDA CENDL
 ADC BYTES CEND:=CEND+BYTES
 STA CENDL
 LDA CENDH
 ADCIM $00
 STA CENDH
 RTS

   RECEND REDUCES THE CURRENT END ADDRESS
   BY THE AMOUNT IN BYTES

RECEND SEC
 LDA CENDL
 SBC BYTES CEND:=CEND-BYTES
 STA CENDL
 LDA CENDH
 SBCIM $00
 STA CENDH
 RTS

   NEXT ADVANCES THE CURRENT DISPLAYED ADDRESS
   DOWNWARD BY THE AMOUNT IN BYTES

NEXT CLC
 LDA CURADL
 ADC BYTES CURAD:=CURAD+BYTES
 STA CURADL
 LDA CURADH
 ADCIM $00
 STA CURADH
 SEC
 LDA CURADL
 SBC CENDL
 LDA CURADH
 SBC CENDH
 RTS

   THE LOOKUP TABLE "LOOK" IS USED TO CONVERT
   A HEX NUMBER INTO A 7 SEGMENT PATTERN.
   THE LOOKUP TABLE "LEN" IS USED TO CONVERT AN
   INSTRUCTION INTO AN INSTRUCTION LENGTH.

LOOK = $40      "0"
 = $79      "1"
 = $24      "2"
 = $30      "3"
 = $19      "4"
 = $12      "5"
 = $02      "6"
 = $78      "7"
 = $00      "8"
 = $10      "9"
 = $08      "A"
 = $03      "B"
 = $46      "C"
 = $21      "D"
 = $06      "E"
 = $0E      "F"

LEN = $02
 = $02
 = $02
 = $01
 = $02
 = $02
 = $02
 = $01
 = $01
 = $02
 = $01
 = $01
 = $03
 = $03
 = $03
 = $03

 JMI NMIL JUMP TO USER SELECTABLE NMI VECTOR
 JMI IRQL JUMP TO USER SELECTABLE IRQ VECTOR

   GETLBL IS AN ASSEMBLER SUBROUTINE. IT SEARCHES FOR
   LABELS ON THE SYMBOL PSEUDO STACK. IF THIS STACK
   CONTAINS A VALID LABEL IT RETURNS WITH THE
   HIGH ORDER LABEL ADDRESS IN X AND THE LOW ORDER LABEL
   ADDRESS IN A. IF NO VALID LABEL IS FOUND IT RETURNS
   WITH Z=1.

GETLBL LDAIY CURADL FETCH CURRENT LABEL NUMBER FROM WS
 LDYIM $FF RESET PSEUDO STACK
SYMA CPY LABELS UPPER MOST SYMBOL TABLE ADDRESS?
 BEQ SYMB THEN RET. NO LABEL ON PSEUDO STACK
 CMPIY TABLEL LABEL NR. WS = LABEL NR. PS?
 BNE SYMNXT
 DEY  IF YES GET HIGH ORDER ADDRESS
 LDAIY TABLEL
 TAX  DISCARD HIGH ORDER ADDRESS IN X
 DEY
 LDAIY TABLEL GET LOW ORDER ADDRESS
 LDYIM $01 PREPARE Y REGISTER
SYMB RTS

SYMNXT DEY          *********   *********
 DEY          * X=ADH *   * A=ADL *
 DEY          *********   *********
 BNE SYMA
 RTS


