
   SUBROUTINE TO SEND ONE 8 BIT BYTE

OUTCHT LDYIM $08 EIGHT BIT COUNT
 STY COUNT
TRY LDYIM $02 START AT
 STY TRIB 3600 HERTZ
ZON LDXAY NPUL NUMBER OF HALF CYCLES
 PHA  SAVE THE CHAR

ZONA BIT $1747 WAIT FOR END OF CYCLE
 BPL ZONA IN TIGHT LOOP

 LDAAY TIMG SET UP TIMER
 STA $1744 FOR THIS PULSE

 LDA GANG CHANGE STATE
 EORIM $80 OF OUTPUT
 STA $1742 PORT

 STA GANG AND SAVE STATE
 DEX  DONE ALL CYCLES?
 BNE ZONA NO-THEN SEND ANOTHER

 PLA  RETRIEVE BYTE
 DEC TRIB ONE MORE GONE
 BEQ SETZ THE LAST ONE, TOO
 BMI ROUT EVEN THE LAST ONE WENT

 LSRA  ANOTHER BIT TO THE CARRY
 BCC ZON IF IT IS NOT SET
SETZ LDYIM $00 SWITCH TO 2400 HZ
 BEQ ZON ALWAYS

ROUT DEC COUNT ONE BIT SENT
 BNE TRY BUT MORE TO GO
 RTS  ALL OVER, GO HOME

   TIMING TABLE

NPUL = $02 TWO PULSES
TIMG = $C3 THE RIGHT TIME
 = $03 3 PULSES
 = $7E AND ENOUGH TIME

   IF YOUR RECORDER CANNOT HANDLE THIS SPEED
   YOU CAN SLOW DOWN BY CHANGING NPUL AND NPUL+02
   TO ONE OF THE FOLLOWING:      03       04
                                 06       09
   (THIS IS THE KIM ROM SPEED)   0C       12


