
   ERASE TO END OF SCREEN

ERTEOS LDX INLINE LAST LINE?
 INX
 CPX LPSCR
 BEQ ERTEOL THEN ONLY EOL
 JSR ERTEOL

EREOS CLC
 LDA SCRPTR
 ADC CHAPLN SCRPTR +:= CHAPLN
 STA SCRPTR OR SCREENPOINTER DOWN
 LDA SCRPTR +01
 ADCIM $00
 ANDIM $07 MAX IS $7FF
 STA SCRPTR +01
 CMP LLN +01 SCRPTR = LINE?
 BNE EEOL
 LDA SCRPTR
 CMP LLN
 BEQ EEOLB ERASE LAST LINE, STOP

EEOL STY TEMCOL TEMCOL := 0
 JSR EREOL
 BCS EREOS

EEOLB STY TEMCOL TEMCOL := 0
 BEQ EREOL

   ERASE FIRST LINE

ERAFLN LDYIM $00
 STY TEMCOL
 LDXIM $20
 LDA FLN
 STA SCRPTR SCRPTR := FLN
 LDA FLN +01
 STA SCRPTR +01
 JMP EREOL ERASE FIRTS LINE

   ERASE LAST LINE

ERALLN LDYIM $00
 STY TEMCOL TEMCOL := 0
 LDXIM $20
 LDA LLN
 STA SCRPTR SCRPTR := LLN
 LDA LLN +01
 STA SCRPTR +01
 JMP EREOL ERASE LAST LINE

   PUT A CHARACTER ON THE SCREEN

TVPUT CLC
 LDA CLN
 ADC RAMBEG
 STA RAMPTR RAMPTR +:= CLN
 LDA CLN +01
 ADC RAMBEG +01
 STA RAMPTR +01
 LDYIM $00
 CLC
 LDA COL RAMPTR +:= CLN+COL
 ADC RAMPTR
 STA RAMPTR
 BCC TPX
 INC RAMPTR +01
 LDA RAMPTR +01
 ANDIM VREND /
 STA RAMPTR +01

TPX LDA AHOLD
 STAIY RAMPTR
 INC COL COL +:= 1
 JMP ADJUST

   CURSOR DOWN

CURDN INC INLINE INLINE +:= 1
 JSR CLNDN CURRENT LINE DOWN
 LDY INLINE
 CPY LPSCR INLINE >= LPSCR?
 BCC CURDNX BRANCH ON NO
 JSR FLNDN FIRST LINE DOWN
 JSR FLNCRT FIRST LINE TO CRT
 JSR LLNDN LAST LINE DOWN
 JSR ERALLN ERASE LAST LINE
 LDY LPSCR
 DEY
 STY INLINE INLINE := LPSCR-1

CURDNX JMP ADJCUR ADJUST CURSOR, RETURN

   CURSOR UP

CURUP DEC INLINE INLINE -:= 1
 JSR CLNUP CURRENT LINE UP
 LDY INLINE INLINE < 0?
 BPL CURUPX BRANCH ON NO
 JSR FLNUP FISRT LINE UP
 JSR FLNCRT FLN TO CRT
 JSR LLNUP LAST LINE UP
 JSR ERAFLN ERASE THE FIRST LINE
 LDYIM $00
 STY INLINE INLINE := 0

CURUPX JMP ADJCUR ADJUST CURSUR, RETURN

   CURSOR LEFT

CURLFT DEC COL COL -:= 1
 JMP ADJUST ADJUST CURSOR, RETURN

   CURSOR RIGHT

CURRGT INC COL COL +:= 1
 JMP ADJUST ADJUST CURSOR, RETURN

   HOME CURSOR

HOME LDXIM $00
 STX INLINE INLINE := 0
 STX COL COL := 0
 LDX FLN
 STX CLN CLN := FLN
 LDX FLN +01
 STX CLN +01
 JMP ADJUST ADJUST CURSOR, RETURN

   MASTER RESET

RESET LDAIM $00
 STA FLN FLN := 0
 STA FLN +01
 STA CLN CLN := 0
 STA CLN +01
 STA LLN LLN := 0
 STA LLN +01
 STA COL COL := 0
 STA INLINE INLINE := 0
 LDX LPSCR
 DEX  X := LPSCR-1

RSA CLC
 LDA CHAPLN
 ADC LLN
 STA LLN LLN := (LSCPTR-1)*CHAPLN
 BCC RSB
 INC LLN +01

RSB DEX
 BNE RSA
 JSR CRTINT SET CRTC TIMING REGS
 JSR HOME HOME CURSOR
 JSR ERTEOS CLEAR SCREEN
 JMP FLNCRT FLN TO CRT, RETURN

   INITIALISE CRTC

CRTINT LDXIM $00
   SET THE FILE INDEX
 LDAAX TABLE
 STA RFILE VALUE TO FILE
 INX
 CMPIM $10 ONLY THE TIMING REGS
 BNE CIA
 RTS
