
   ***** KIM CASSETTE WRITE SUBROUTINE *****

   ADAPTED FROM SUPERTAPE BY JIM BUTTERFIELD
   AS PUBLISHED IN KIM-1 USER NOTES (V I,N 2)


CWRITE LDA $1702 TURN ON CASSETTE #2
 ANDIM $F7 BY SETTING BIT 3 = 0
 STA $1702 IN PIA PORT B

 LDAIM $AD SET UP
 STA VEB VEB FOR SAVE
 JSR INTVEB

 LDAIM $27 SET FLAG
 STA GANG FOR SBD LATER

 LDAIM $BF TURN ON
 STA $1743 OUTPUT TO CASSETTE

 LDXIM $F0 SEND 240 SYNC PULSES

 LDAIM $16 SYNC CHARACTER
 JSR HIC OUTPUT X TIMES

 LDAIM $2A SEND START OF DATA CHAR
 JSR OUTCHT

 LDA ID GET ID
 JSR OUTBT AND SEND AS A BYTE

 LDA SALX SEND EXECUTION ADDRESS
 JSR OUTBTC WITH CHECKSUM CALCULATION
 LDA SAHX HI PART TOO
 JSR OUTBTC

DUMPTA JSR VEB GET A BYTE OF MEMORY
 JSR OUTBTC SEND AND CHECKSUM IT
 JSR INCVEB POINT TO NEXT BYTE
 LDA VEB +01 CHECK FOR END
 CMP EAL AGAINST EAL
 LDA VEB +02 AND
 SBC EAH EAH
 BCC DUMPTA AGAIN IF NOT END

 LDAIM $2F SEND END OF DATA CHAR
 JSR OUTCHT AS CHAR

 LDA CHKL SEND
 JSR OUTBT CHECKSUM
 LDA CHKH LO AND
 JSR OUTBT HI
 LDXIM $02 AND SEND 2
 LDAIM $04 EOT CHARS
 JSR HIC

 LDA $1702 TURN OFF CASSETTE
 ORAIM $08 BY SETTING BIT 3
 STA $1702 OF THE CONTROL PORT
 JMP INIT RESET ALL PORTS

   SUBROUTINE TO SEND X CHARACTERS TO TAPE

HIC STX TIC SAVE THE COUNT
HICA PHA  AND THE CHARACTER
 JSR OUTCHT SEND THE CHAR
 PLA  AND GET IT BACK
 DEC TIC TO SEND AGAIN
 BNE HICA UNTIL COUNT = 0
 RTS

   SUB TO SEND CHAR WITH CHECKSUM CALCULATION

OUTBTC JSR CHKT ADD CHAR TO SUM

   SUB TO SEND BYTE AS TWO ASCII CHARS

OUTBT PHA  SAVE BYTE
 LSRA  GET
 LSRA  UPPER
 LSRA  NIBBLE
 LSRA
 JSR HEXT AND SEND IT
 PLA  RETURN BYTE

   SUB TO SEND ONE HEX CHAR AS ASCII

HEXT ANDIM $0F CLEAN UP DATA
 CMPIM $0A CHANGE TO ASCII
 CLC  BY ADDING
 BMI HEXAT
 ADCIM $07 37 TO A...F
HEXAT ADCIM $30 AND 30 TO 0...9


