
   EDITOR'S SUBROUTINES

   SCAN IS A SUBROUTINE, FILLING UP
   THE DISPLAY BUFFER DETERMINED BY
   CURAD. THEN THE DISPLAY IS SCANNED
   DEPENDING OF THE LENGTH OF THE INSTRUCTION
   POINTED BY CURAD.
   IF A DEPRESSED KEY IS DETECTED
   SCAN RETURNS WITH VALUE IN ACCU.

SCAN LDXIM $02 FILL UP THE DISPLAY BUFFER
 LDYIM $00
FILBUF LDAIY CURADL START FILLING AT OP CODE
 STAZX INH
 INY
 DEX
 BPL FILBUF
 JSR OPLEN STORE INSTRUCTION LENGTH IN BYTES
SCANA JSR SCANDS DISPLAY CURRENT INSTRUCTION
 BNE SCANA KEY RELEASED?
SCANB JSR SCANDS DISPLAY CURRENT INSTRUCTION
 BEQ SCANB ANY KEY DEPRESSED?
 JSR SCANDS DISPLAY CURRENT INSTRUCTION
 BEQ SCANB ANY KEY STILL DEPRESSED?
 JSR GETKEY IF YES, RETURN WITH KEY IN ACCU
 RTS

   GETBYT READS 2 HEXKEYS AND COMPOSES
   THEIR VALUE IN THE A REGISTER. IF ONLY
   HEXKEYS WERE DEPRESSED, IT RETURNS WITH
   N=1. IF A COMMAND KEY WAS DEPRESSED, IT
   RETURNES WITH N=0.
 
GETBYT JSR SCANA READ HIGH ORDER NIBBLE
 CMPIM $10
 BPL BYTEND COMMAND KEY?
 ASLA
 ASLA  IF NOT, SAVE HIGH ORDER NIBBLE
 ASLA
 ASLA
 STA NIBBLE
 JSR SCANA READ LOW ORDER NIBBLE
 CMPIM $10
 BPL BYTEND COMMAND KEY?
 ORA NIBBLE IF NOT COMPOSE BYTE
 LDXIM $FF SET N=1
BYTEND RTS

   SCAND IS A SUBROUTINE SHOWING DATA SPECIFIED BY
   POINT.
   SCANDS IS A SUBROUTINE SHOWING THE CONTENTS OF
   DISPLAY BUFFER AS A FUNCTION OF BYTES.
   THE FOLLOWING SUBROUTINE AK SCANS THE KEYBORD.
   IT RETURNS WITH A=0, IF NO KEY IS DEPRESSED AND
   WITH A<>0 IF A KEY IS DEPRESSED.
   WHEN SCAND OR SCANDS ARE LEFT, PA0...PA7 IS INPUT.

SCAND LDYIM $00
 LDAIY POINTL GET DATA SPECIFIED BY POINT
 STA INH
SCANDS LDAIM $7F
 STA PADD PA0...PA6 IS OUTPUT
 LDXIM $08 ENABLE DISPLAY
 LDY BYTES FETCH LENGTH FROM BYTES
SCDSA LDA POINTH OUTPUT 1ST BYTE
 JSR SHOW
 DEY
 BEQ SCDSB MORE BYTES?
 LDA POINTL
 JSR SHOW IF YES, OUTPUT 2ND BYTE
 DEY
 BEQ SCDSB MORE BYTES?
 LDA INH
 JSR SHOW IF YES, OUTPUT 3RD BYTE
SCDSB LDAIM $00
 STA PADD PA0...PA7 IS INPUT

AK LDYIM $03 SCAN 3 ROWS
 LDXIM $00 RESET ROW COUNTER

ONEKEY LDAIM $FF
AKA STX PBD OUTPUT ROW NUMBER
 INX  ENABLE FOLLOWING ROW
 INX
 AND PAD INPUT ROW PATTERN
 DEY  ALL ROWS SCANNED?
 BNE AKA
 LDYIM $06 TURN DISPLAY OFF
 STY PBD
 ORAIM $80 SET BIT7=1
 EORIM $FF INVERT KEY PATTERN
 RTS


