



   ASSEMBLER MAIN ROUTINE

   FOLLOWING INSTRUCTIONS ARE ASSEMBLED:

   JSR INSTRUCTION
   JMP INSTRUCTION
   BRANCH INSTRUCTIONS



ASSEMB SEC
 LDA ENDADL
 SBCIM $FF
 STA TABLEL TABLE:=ENDAD-$FF
 LDA ENDADH
 SBCIM $00
 STA TABLEH
 LDAIM $FF
 STA LABELS
 JSR BEGIN CURAD:=BEGAD

PASSA JSR OPLEN START PASS ONE, GET CURR. INSTR.
 LDYIM $00
 LDAIY CURADL FETCH CURRENT INSTRUCTION
 CMPIM $FF IS THE CURRENT INSTRUCTION A LABEL?
 BNE NXTINS
 INY
 LDAIY CURADL IF YES FETCH LABEL NR.
 LDY LABELS
 STAIY TABLEL DEPOSIT LABEL NR. ON SYMBOL STACK
 DEY
 LDA CURADH GET HIGH ORDER ADDRESS
 STAIY TABLEL DEPOSIT ON SYMBOL STACK
 DEY
 LDA CURADL GET LOW ORDER ADDRESS
 STAIY TABLEL DEPOSIT ON SYMBOL STACK
 DEY
 STY LABELS ADJUST PSEUDO STACK POINTER
 JSR UP DELETE CURRENT LABEL IN WS
 JSR RECEND ADJUST CURRENT END ADDRESS
 JMP PASSA LOOK FOR MORE LABELS

NXTINS JSR NEXT IF NO LABEL SKIP TO NEXT INSTR.
 BMI PASSA ALL LABELS IN WS COLLECTED?
 JSR BEGIN START PASS 2
PASSB JSR OPLEN GET LENGTH OF THE CURRENT INSTR.
 LDYIM $00
 LDAIY CURADL FETCH CURRENT INSTR.
 CMPIM $4C JMP INSTR.?
 BEQ JUMPS
 CMPIM $20 JSR INSTR.?
 BEQ JUMPS
 ANDIM $1F STRIP TO 5 BITS
 CMPIM $10 ANY BRANCH INSTRUCTION?
 BEQ BRINST
PB JSR NEXT IF NOT RETURN
 BMI PASSB ALL LABELS ASSEMBLED?
 LDAIM $03 ENABLE 3 DISPLAY BUFFERS
 STA BYTES
 JMP START EXIT HERE  ********


JUMPS INY  SET POINTER TO LABEL NR.
 JSR GETLBL GET LABEL ADDRESS
 BEQ PB RETURN IF NOT FOUND
 STAIY CURADL STORE LOW ORDER ADDRESS
 TXA
 INY
 STAIY CURADL STORE HIGH ORDER ADDRESS
 BNE PB

BRINST INY  SET POINTER TO LABEL NR.
 JSR GETLBL GET LABEL ADDRESS
 BEQ PB RETURN IF NOT FOUND
 SEC
 SBC CURADL COMPUTE BRANCH OFFSET
 SEC
 SBCIM $02 DESTINATION-SOURCE-2=OFFSET
 STAIY CURADL INSERT BRANCH OFFSET IN WS
 JMP PB


   THE SUBROUTINE BRANCH COMPUTES THE OFFSET OF BRANCH
   INSTRUCTIONS. THE 2 RIGHT HAND DISPLAYS SHOW THE
   COMPUTED OFFSET DEFINED BY THE 4 LEFT HAND DISPLAYS.
   THE PROGRAM MUST BE STOPPED WITH THE RESET KEY.

BRANCH CLD
 LDAIM $00 RESET DISPLAY BUFFER
 STA POINTH
 STA POINTL
 STA INH
BR JSR GETBYT READ SOURCE
 BPL BRANCH COMMAND KEY?
 STA POINTH SAVE SOURCE IN BUFFER
 JSR GETBYT READ DESTINATION
 BPL BRANCH COMMAND KEY?
 STA POINTL SAVE DESTINATION IN BUFFER
 CLC
 LDA POINTL FETCH DESTINATION
 SBC POINTH SUBTRACT SOURCE
 STA INH
 DEC INH EQUALIZE AND SAVE OFFSET IN BUFFER
 JMP BR

   END OF JUNIOR'S MONITOR


 = $FF EMPTY
 = $FF EMPTY

   VECTORS AT THE END OF THE MEMORY:

 = $2F NMI VECTOR
 = $1F
 = $1D RESET VECTOR
 = $1C
 = $32 IRQ/BRK VECTOR
 = $1F


