RAMTST ORG $0300



BEG * $0000 BEGIN ADDRESS
END * $0002 END ADRRESS
PATTER * $0004 TEST BYTE FOR TEST
RET * $0005 ERROR RETURN CODE
CUR * $0006 MEMORY ADDR. POINTER
CNT * $0008 CYCLE COUNTER
ERCNT * $000A ERROR COUNTER


BLFLAG * $1A4C PRINTER FLAG
HEXOUT * $C919 PRINTS A HEX BYTE
OUTSP * $C936 PRINTS A SPACE
HEXSP * $C933 PRINTS 2 HEX BYTES (A,X) + SPACE
CRLF * $C92F PRINTS A CR-LF
BRKTST * $C961 BREAKTEST FROM CONSOLE




PRELUD LDAIM $00 DEFAULT BEG,END
 STA BEG
 LDAIM $20
 STA BEG +01
 LDAIM $FF
 STA END
 LDAIM $9F
 STA END +01

INIT LDXIM $00
 STX ERCNT +01 ERCNT := 0000
 STX ERCNT
 STX CNT +01 CNT := 0001
 INX
 STX CNT

MAIN JSR TSTZRO TEST WITH ZERO'S
 JSR WALKUP TEST EACH BIT FROM BEG TO END
 JSR TSTZRO MAKE ALL ZERO AGAIN
 JSR WLKDWN TEST EACH BIT DOWNWARD
 JSR OUTCNT PRINT LAST CYCLE NUMBER + ERCNT
 JSR INCCNT CNT +:= 1
 JMP MAIN AND START OVER

TSTZRO LDAIM $01
 STA RET 01 = RETCODE FROM TSTZRO
 LDAIM $00
 STA PATTER WRITE ZERO'S
 JSR BEGCUR CUR := BEG
ZRO JSR TEST WRITE ZERO AND TEST IT
 JSR INCCUR CUR +:= 1
 BCS ZRO IF CUR <= END
 RTS

WALKUP LDAIM $02
 STA RET 02 = RETCODE FROM WALKUP
 JSR BEGCUR CUR := BEG
UP JSR WALK TEST EACH BIT
 JSR INCCUR CUR +:= 1
 BCS UP IF CUR <= END
 RTS

WLKDWN LDAIM $03
 STA RET 03 = RETCODE FROM WLKDWN
 JSR ENDCUR CUR := END
DWN JSR WALK TEST EACH BIT
 JSR DECCUR CUR -:= 1
 BCS DWN IF CUR >= BEG
 RTS

WALK LDAIM $00 FIRST CHECK IF ZERO
 STA PATTER TO DETECT ADDRESS ERRORS
 LDYIM $00
 JSR ADTEST
 LDAIM $01 TEST EACH BIT
 STA PATTER
WALKON JSR TEST
 ASL PATTER
 BNE WALKON
 LDAIM $FF LEAVE A FF TO
 STA PATTER DETECT ADDRESSING ERRORS
 JSR TEST
 RTS

TEST LDYIM $00
 LDA PATTER (CUR) := PATTER
 STAIY CUR
ADTEST LDAIY CUR GET IT (BACK)
 CMP PATTER
 BEQ TESTED IF MATCH
 JSR ERROR ELSE PRINT ERROR
TESTED JSR BRKTST
 RTS

ERROR PHA  SAVE READED BYTE
 JSR INCERC COUNT ERROR
 LDA CNT +01 PRINT CYCLE NUMBER
 LDX CNT
 JSR HEXSP
 LDA RET PRINT RETURNCODE
 JSR HEXOUT
 JSR OUTSP
 LDA CUR +01 PRINT ADDRESS
 LDX CUR
 JSR HEXSP
 LDA PATTER PRINT WAT IT HAD TO BE
 JSR HEXOUT
 JSR OUTSP
 PLA  PRINT WAT IT WAS
 JSR HEXOUT
 JSR CRLF
 RTS

INCCUR CLC  CUR +:= 1
 LDA CUR
 ADCIM $01
 STA CUR
 LDA CUR +01
 ADCIM $00
 STA CUR +01
 SEC  END - CUR
 LDA END
 SBC CUR
 LDA END +01
 SBC CUR +01
 RTS  C=1 IF CUR <= END

DECCUR SEC CUR -:= 1
 LDA CUR
 SBCIM $01
 STA CUR
 LDA CUR +01
 SBCIM $00
 STA CUR +01
 SEC  CUR - BEG
 LDA CUR
 SBC BEG
 LDA CUR +01
 SBC BEG +01
 RTS  C=1 IF CUR >= BEG

BEGCUR LDA BEG CUR := BEG
 STA CUR
 LDA BEG +01
 STA CUR +01
 RTS

ENDCUR LDA END CUR := END
 STA CUR
 LDA END +01
 STA CUR +01
 RTS

OUTCNT LDA BLFLAG
 PHA  DISABLE PRINTER
 LDAIM $00
 STA BLFLAG
 LDA CNT +01 PRINT CNT
 LDX CNT
 JSR HEXSP
 LDA ERCNT +01 PRINT ERCNT
 LDX ERCNT
 JSR HEXSP
 JSR CRLF
 PLA
 STA BLFLAG
 RTS

INCCNT SED CNT +:= 1 (DECIM)
 SEC
 LDA CNT
 ADCIM $00
 STA CNT
 LDA CNT +01
 ADCIM $00
 STA CNT +01
 CLD
 RTS

INCERC SED ERCNT +:= 1 (DECIM)
 SEC
 LDA ERCNT
 ADCIM $00
 STA ERCNT
 LDA ERCNT +01
 ADCIM $00
 STA ERCNT +01
 CLD
 RTS
