
   COMPUTE COMMAND INDEX

COMCOM LDXIM $00
 LDYIM $01

COMCOA LDAAX COMTAB
 CMP ESCFLG FIND THE COMMAND
 BNE COMCOB
 LDAAY COMTAB
 CMP AHOLD
 BNE COMCOB
 CLC  C=0 IF X IS ADDRESS INDEX

COMCOB INX
 INX
 INY
 INY
 CPXIM $16
 BCC COMCOA C=1 IF NO COMMAND

COMCOC LDAIM $00
 STA ESCFLG RESET ESCAPE FLAG
 RTS

   COMMAND TABLE

COMTAB = $00
 = $0D CR
 = $00
 = $0A LF
 = $00
 = $08 BS
 = $1B
 = '1 ESC 1 CLEAR SCREEN & HOME
 = $1B
 = '2 ESC 2 CLEAR SCREEN & HOME
 = $1B
 = '3 ESC 3 HOME CURSOR
 = $1B
 = '4 ESC 4 ERASE TO EOS
 = $1B
 = '5 CURSOR UP
 = $1B
 = '6 ESC 6 CURSOR DOWN
 = $1B
 = '8 ESC 8 ERASE TO EOL
 = $00
 = $10 CTL P CURSOR RIGHT

   COMMAND ADDRESS TABLE

COMADR = RETURN
 = RETURN /
 = FEED
 = FEED /
 = LEFT
 = LEFT /
 = CLRHOM
 = CLRHOM /
 = CLRHOM
 = CLRHOM /
 = HOCU
 = HOCU /
 = ERSCRX
 = ERSCRX /
 = UP
 = UP /
 = DOWN
 = DOWN /
 = ERLNX
 = ERLNX /
 = RIGHT
 = RIGHT /

   CRTC FILE TO RAM

MOVCRT LDAIM VRBEG
 LDXIM VRBEG /
 STA RAMBEG
 STX RAMBEG +01
 LDAIM $00
 TAY
 LDX FORMAT GET CURR FORMAT
 BEQ MCRTB

MCRTA CLC
 ADCIM $12 COMPUTE INDEX
 DEX
 BNE MCRTA

MCRTB TAX

MCRTC LDAAX CRTINA
 STAAY TABLE MOVE TABLE
 INX
 INY
 CPYIM $12
 BNE MCRTC
 DEY
 LDAAY TABLE SET SCREEN PARAMETERS
 STA LPSCR
 DEY
 LDAAY TABLE
 STA CHAPLN
 RTS

   CRTINA TABEL

CRTINA = $64
 = $50
 = $4F
 = $33
 = $1C
 = $03
 = $19
 = $1B
 = $00
 = $0B
 = $6B
 = $0B
 = $00
 = $00
 = $00
 = $00
 = $50
 = $19

