 JMP COLDSTRT 
;
 JMP WARMSTRT 
;
 .SI DEFAULTS
 .SI HA.LAYOUT
 .SI EXIT0000
 .SI ERR.0
 .SI HA.LAYOUT1
;
COLDSTRT LDX #$FF 
 TXS  
 INX  
 STX *DISCI 
 STX *DISCO 
 STX PASS 
 STX *SUPPRESS.O 
 STX PRINT/CTL 
 LDA #$3A 
 NOP  
 JSR SET.BOUNDS 
 NOP  
 NOP  
 NOP  
 NOP  
 NOP  
 JSR INIT 
 LDA #1 
 STA LINE_CNTR 
 STA PAGE_NUMB 
 STA FORMAT 
 STA *ERRORS 
 STX INCBY 
 STX INCBY+1 
 STX MANU 
 LDY #MES.COLD-MES.ERROR
 JSR MESSAGE 
 LDA #11
 STA *AUTO.TAB 
@CLEAR JSR TXT.CLEAR 
 STX HFILE/NO 
 JSR PR.BOUNDS 
;
MONL.0.OFF JSR TD.0.OFF 
MONL.1.OFF JSR TD.1.OFF 
MON.LOOP LDX #0
MONLOOP1 CLD  
 NOP  
 NOP  
 NOP  
 LDA #0
 NOP  
 NOP  
 NOP  
 STA PASS 
 STA TABSN 
 JSR OUT.CR 
LN/COM LDX #$FF 
 STX TERM 
 STX HEX/DEC 
 TXS  
 INX  
 STX CON_TAPE 
 STX AU 
 JSR IN/TXT? 
 LDY #0
 JSR NXT.LETTER 
 CPY #80
 BCS LN/COM 
 JSR SRCH.COM 
 LDX #$ED 
 JMP ERR.0 ;ERROR IN COMMAND INPUT
;
TXT.CLEAR LDA TXST 
 STA *TPRES 
 LDA TXST+1 
 STA *TPRES+1 
TXT.END.0 TXA  
 LDY #2
 STA (TPRES),Y 
 RTS  
;
@BREAK LDA #$80 
 NOP  
 NOP  
 NOP  
 BRK  
 NOP  
 NOP  
WARMSTRT JSR PR.BOUNDS 
 JMP MON.LOOP 
;
@AUTO LDX #INCBY-TXST
 JSR GETDECPARM 
 JMP MONLOOP1 
;
@GET JSR GET 
 JMP MON.LOOP 
;
@FORMAT JSR GET.CRT.UP 
 STA FORMAT 
 CMP #'C 
 BNE FORM.SETD 
 STX FORMAT 
FORM.SETD JSR NXT.WORD 
 CPY #80
 BCS MONLOOP1.1 
 STX HEX/DEC 
 LDA #1
 STA PASS 
 JSR OPER/TST 
 INC *PROC_ADDRS 
 LDA *PROC_ADDRS 
 AND #%00011111
 STA *AUTO.TAB 
MONLOOP1.1 JMP MONLOOP1 
;
@MANUSCR JSR GET.CRT.UP 
 STA MANU 
 CMP #'C 
 BNE MONLOOP1.2 
 STX MANU 
MONLOOP1.2 JMP MONLOOP1 
;
@ASSMBLE STX CON_TAPE
 STX PASS 
 TYA  
 PHA  
 JSR SPRES:STST 
 JSR ST.END.0 
 STX HEX/DEC 
 PLA  
 TAY  
 STX TLIST 
 JSR GET.CRT.UP 
 CMP #'N 
 BEQ AS.LC 
 CMP #'L 
 BNE AS.GFRST 
 INC TLIST 
AS.LC JSR NXT.WORD 
AS.GFRST JSR IN.F/L 
 LDA FIRST 
 STA AS_LN_SV 
 LDA FIRST+1 
 STA AS_LN_SV+1 
 JMP ASSEMBLE 
;
@RUN LDA #1
 STX HEX/DEC 
 STA PASS 
 JSR OPER/TST 
 JSR NXT.WORD 
 JSR EX.RUN 
 JMP MONLOOP1 
;
EX.RUN JMP (PROC_ADDRS) 
;
@PRINT LDA CRT,Y 
 CMP #'/ 
 BNE LI.F/L 
 LDA #$FF 
 STA FIRST+1 
 JSR FIND.LNGE 
 LDA CUR.SAVE 
 STA *SCRAT0 
 LDA CUR.SAVE+1 
 STA *SCRAT0+1 
 JSR LI.LINE 
 JMP MONLOOP1 
;
LI.F/L JSR IN.F/L 
 JSR LI.>LAST? 
 JMP MONLOOP1 
;
PUT.RBUF LDA *PURECL 
 STA HSTART 
 CLC  
 ADC REC_POINT 
 STA HEND 
 LDA *PURECH 
 STA HSTART+1 
 ADC #0
 STA HEND+1 
 STX REC_POINT 
PUTIT JSR TD.0.ONW 
 STY *SAVE 
 JSR PUT.H/F 
 LDY *SAVE 
 JSR TD.0.OFW 
 RTS  
;
GET.FILNO STX FILE.NO 
 JSR GET.CRT.UP 
 CMP #'F 
 BNE RET.GFLN 
 INY  
 LDX #LAST-TXST
 JSR GETDECPARM 
 LDA LAST 
 STA FILE.NO 
 JSR NXT.LETTER 
RET.GFLN RTS  
;
LI.>LAST? BEQ LI.>LAST 
 BCC LI.LINE 
LI.LAST? LDY #2
LI.LAST?? DEY  
 BMI LI.LINE 
 LDA LAST,Y 
 CMP (SCRAT0),Y 
 BEQ LI.LAST?? 
 BCS LI.LINE 
LI.>LAST JSR LI.END 
 RTS  
;
LI.LINE JSR CRT:TXTLIN 
 LDA MANU 
 BNE LI.NOLNNR 
 JSR PR.SP/FRST 
 JSR OUT.2SP 
LI.NOLNNR JSR PR.CRT 
 JSR OUT.CR 
 JSR NXT.LIN/LA 
 LDY #2
 LDA (SCRAT0),Y 
 BNE LI.LAST? 
LI.END JSR CLR.SPR.// 
 JSR OUT.CR 
 RTS  
;
CLR.SPR.// STX *SUPPRESS.O 
 LDA #'/ 
 JSR OUTCHAR 
 LDA #'/ 
 JSR OUTCHAR 
 RTS  
;
IN.F/L LDX #FIRST-TXST
 JSR GETDECPARM 
 CPY #80
 BCC IN.LAST 
 LDA #$FF 
 STA LAST+1 
 BNE FIND.LNGE 
;
IN.LAST JSR NXT.LETTER 
 LDX #LAST-TXST
 JSR GETDECPARM 
FIND.LNGE JSR SR0:TXST 
FND.EOF? LDY #2
 LDA (SCRAT0),Y 
 BNE CMP.LNNR 
FND.LNGE CLC  
 RTS  
;
CMP.LNNR DEY  
 BMI FND.LNGE 
 LDA (SCRAT0),Y 
 CMP FIRST,Y 
 BEQ CMP.LNNR 
 BCC LNNRLESS 
 RTS  
;
LNNRLESS LDA *SCRAT0 
 STA CUR.SAVE 
 LDA *SCRAT0+1 
 STA CUR.SAVE+1 
 JSR NXT.LIN/LA 
 JMP FND.EOF? 
;
ST.IN.RBUF STY *SAVE 
 LDY REC_POINT 
 STA (PURECL),Y 
 INC REC_POINT 
 LDY *SAVE 
 RTS  
;
SE/I/LOW LDA PASS 
 BPL SE/I.NP2 
 LDA #$4F 
 INC HEX/DEC 
 JSR ST/PR.OB 
SE/I.NP2 JMP ST/PR.LOPR 
;
GETFRSTCH LDY #2
 LDA (SCRAT0),Y 
 RTS  
;
EX.PASS2 INC PASS 
 JMP AS.AUTO.P2 
;
IN/TXT? JSR IN.LINE 
 LDY #0
 LDA CRT,Y 
 CMP #'0 
 BCC IN.NOTXT 
 CMP #':
 BCC IN.TXTLINE 
IN.NOTXT RTS  
;
IN.TXTLINE LDX #FIRST-TXST
 JSR PARM 
 STY *SCRAT3 
 LDA ADDPAD 
 SEC  
 SBC *SCRAT3 
 STA ADDPAD 
SRCH.ENTRY JSR FI.LN/DEL 
 LDY *SCRAT3 
 JSR NXT.LETTER 
 CPY #80
 BCS AU? 
 LDY *SCRAT3 
 JSR INSRT.LN 
AU? JSR ADJ.AU 
 BEQ LN/COM.1 
 LDA FIRST 
 CLC  
 SED  
 ADC INCBY 
 STA FIRST 
 LDA FIRST+1 
 ADC INCBY+1 
 STA FIRST+1 
 CLD  
 JSR PR.FIRST 
 JSR IN.LINE 
 LDY #0
 STY *SCRAT3 
 JSR CMP.// 
 BNE SRCH.ENTRY 
 JSR OUT.CR 
LN/COM.1 JMP LN/COM 
;
CMP.// LDY #0
 JSR NXT.LETTER 
 LDA CRT,Y 
 CMP #'/ 
 BNE RET3 
 CMP CRT+1,Y 
RET3 RTS  
;
PARMDCML JSR PARM 
 CPY #80
 BCS RET4 
 LDA *SCRAT1 
 BEQ RET4 
ILLCHINDEC LDX #0
 JMP ERR.9 ;ILL CHAR IN DECIMAL STRING 
;
RET4 RTS  
;
GETDECPARM JSR PARMDCML 
 LDA #$20 
 CMP CRT,Y 
 BNE ILLCHINDEC 
 RTS  
;
ADJ.AU CLC  
 LDA INCBY 
 ADC INCBY+1 
 STA AU 
 RTS  
;
INSRT.LN TYA  
 PHA  
 JSR SR12:TPRES 
 LDA ADDPAD 
 SEC  
 ADC *TPRES 
 PHA  
 TXA  
 ADC *TPRES+1 
 CMP TXEN+1 
 BCC NEW.TPRES 
 BEQ TXT.OVFLW? 
TXT.OVFLW JMP ERR.F ;TEXT FILE OVERFLOW 
;
TXT.OVFLW? TAY  
 PLA  
 CMP TXEN 
 BCS TXT.OVFLW 
 PHA  
 TYA  
NEW.TPRES STA *TPRES+1 
 PLA  
 STA *TPRES 
 JSR SR34:TPRES 
 JMP MOVEDUP? 
;
MOVEUP JSR DEC.SCR12 
 JSR DEC.SCR34 
 LDA (SCRAT1,X) 
 STA (SCRAT3,X) 
MOVEDUP? LDA *SCRAT0 
 CMP *SCRAT1 
 BNE MOVEUP 
 LDA *SCRAT0+1 
 CMP *SCRAT2 
 BNE MOVEUP 
 LDY #0
 LDA FIRST 
 STA (SCRAT0),Y 
 LDA FIRST+1 
 INY  
 STA (SCRAT0),Y 
 PLA  
 TAX  
ADD.LINE INY  
 LDA CRT,X 
 INX  
 STA (SCRAT0),Y 
 CPY ADDPAD 
 BNE ADD.LINE 
 ORA #%10000000
 STA (SCRAT0),Y 
 LDX #0
 JSR TXT.END.0 
 RTS  
;
FI.LN/DEL JSR FIND.LNGE 
 BNE DELIFEQ 
RET.F RTS  
;
DELIFEQ BCS RET.F 
 JSR SR12:SR0 
 JSR NXT.LIN/LA 
MOVEDOWN LDY #2
 LDA (SCRAT0),Y 
 BNE MVD.LNNR 
 LDA *SCRAT1 
 STA *TPRES 
 LDA *SCRAT2 
 STA *TPRES+1 
 JSR TXT.END.0 
 JSR FIND.LNGE 
 RTS  
;
MVD.LNNR LDA (SCRAT0,X) 
 STA (SCRAT1,X) 
 JSR INC.SCR0 
 JSR INC.SCR12 
 DEY  
 BNE MVD.LNNR 
MVD.LINE LDA (SCRAT0,X) 
 STA (SCRAT1,X) 
 PHP  
 JSR INC.SCR0 
 JSR INC.SCR12 
 PLP  
 BPL MVD.LINE 
 BMI MOVEDOWN 
;
NXT.LIN/LA JSR INC.SCR0 
NXT.NOTFND JSR INC.SCR0 
 LDA (SCRAT0,X) 
 BPL NXT.NOTFND 
 JSR INC.SCR0 
 RTS  
;
CRT:TXTLIN JSR CLR.CRTBUF 
 LDA (SCRAT0),Y 
 STA FIRST 
 INY  
 LDA (SCRAT0),Y 
 STA FIRST+1 
 INY  
 LDA FORMAT 
 BEQ UNTILEOL 
 LDA (SCRAT0),Y 
 CMP #'; 
 BEQ UNTILEOL 
 CMP #$20 
 BEQ MNEM.FIELD 
 JSR ONEWORD 
MNEM.FIELD JSR TONXTWRD 
 LDX *AUTO.TAB 
 CMP #'; 
 BEQ UNTILEOL 
 JSR ONEWORD 
 JSR TONXTWRD 
 CMP #'; 
 BEQ COMM.FIELD 
 JSR ONEWORD 
 JSR TONXTWRD 
 CMP #'; 
 BNE UNTILEOL 
COMM.FIELD JSR X:NXTTAB 
UNTILEOL JSR ONEWORD 
 JMP UNTILEOL 
;
TONXTWRD LDA (SCRAT0),Y 
 INY  
 CMP #$20 
 BEQ TONXTWRD 
 DEY  
 RTS  
;
 .CT
